<template>
  <div>
    <h1 class="form-title">Add existing repository for approval</h1>
    <el-row :gutter="20">
      <el-col :span="20">
        <el-form-item label="Repo-Url:" prop="repo_url">
          <el-input v-model="model.repo_url"></el-input>
        </el-form-item>
      </el-col>

      <el-button
        type="primary"
        @click="searchRepoData"
        :disabled="!model.repo_url"
        >Search</el-button
      >
    </el-row>
    <el-form-item label="Repo-Name:" prop="repo_name">
      <el-input v-model="model.repo_name" disabled></el-input>
    </el-form-item>
    <el-form-item label="Repo-Id: " prop="repo_id">
      <el-input v-model="model.repo_id" disabled></el-input>
    </el-form-item>
    <el-form-item label="No. of Approvers: " prop="no_of_approvers">
      <el-input v-model.number="model.no_of_approvers"></el-input>
    </el-form-item>
    <el-row :gutter="20">
      <el-col :span="20">
        <el-form-item label="Search for Username: " prop="approvers">
          <el-select
            v-model="value"
            type="textarea"
            multiple
            filterable
            remote
            :remote-method="remoteMethod"
            :disabled="!model.repo_id"
            :loading="loading"
          >
            <el-option
              v-for="item in options"
              :key="item.id"
              :label="item.name"
              :value="item.username"
            />
          </el-select>
        </el-form-item>
      </el-col>

      <el-form-item>
        <el-button type="primary" @click="addApproversIdToFormData"
          >Add</el-button
        >
      </el-form-item>
    </el-row>
    <el-form-item label="Already added Approvers">
      <el-tag
        v-for="tag in tags"
        :key="tag.index"
        closable
        @close="handleCloseTag(tag)"
      >
        {{ tag }}
      </el-tag>
    </el-form-item>

  </div>
</template>
<script>
import { mapState } from "vuex";
export default {
  name: "CreateRepoPopup",
  props: ["apiParams"],
  data() {
    return {
      loading: false,
      options: [],
      value: [],
      tags: [],
      model: {
        repo_url: "",
        repo_name: "",
        repo_id: undefined,
        no_of_approvers: "",
        approvers: [],
      },
    };
  },
  computed: {
    ...mapState({
      emails: (state) => state.repository.emails,
    }),
    rules() {
      return {
        repo_url: [
          { required: true, message: "Please input repo url", trigger: "blur" },
        ],
        no_of_approvers: [
          {
            required: true,
            message: "Please input repo id",
            trigger: "change",
          },
          { type: "number", message: "No of approvers must be a number" },
        ],
        approvers :[
          {
            required: true,
            message: "Please Click on add button",
            trigger: "change",
          }
        ]
      };
    },
  },
  methods: {
    handleCloseTag(tag) {
      this.model.approvers.splice(this.model.approvers.indexOf(tag), 1);
      this.tags.splice(this.tags.indexOf(tag), 1);
    },
    remoteMethod(query) {
      let fullurl = new URL(this.model.repo_url);
      let baseurl = fullurl.origin;
      // console.log(baseurl)
      if (query !== "") {
        this.loading = true;
        const config = {
          method: "post",
          url: "/search-user",
          data: {
            requrl: baseurl,
            query: query,
          },
        };
        this.$axios(config)
          .then((res) => {
            this.options = res.data;
            this.loading = false;
          })
          .catch((err) => {
            console.log(err);
          });
      }
    },
    addApproversIdToFormData() {
      let newarr = this.model.approvers;
      let tagarr = this.tags;
      this.value.forEach(async (approver) => {
        let payload = {
          url: `items/approvers?&filter[email]=${approver}`,
        };
        await this.$store.dispatch("getField", payload).then((resdata) => {
          if (resdata.length > 0 && resdata[0].email == approver) {
            let obj = {};
            obj["approvers_approvers_id"] = resdata[0].approvers_id;
            tagarr.push(approver);
            newarr.push(obj);
          } else {
            let obj = {};
            obj["email"] = approver;
            let finalobj = {};
            finalobj["approvers_approvers_id"] = obj;
            tagarr.push(approver);
            newarr.push(finalobj);
          }
        });
        this.model.approvers = newarr;
        this.tags = tagarr;
        this.value = [];
      });
    },
    // to check if there is / in in end of url
    checkPath(path) {
      if (path.substring(path.length - 1) == "/") {
        let finalpath = path.slice(0, -1);
        return finalpath;
      } else {
        return path;
      }
    },
    async searchRepoData() {
      let fullurl = new URL(this.model.repo_url);
      let baseurl = fullurl.origin;
      let path = fullurl.pathname.substring(1);
      let finalpath = this.checkPath(path);
      let encodedpath = encodeURIComponent(finalpath);

      let finalobj = {
        gitlab_url: baseurl,
        encodedpath: encodedpath,
      };

      let data = await this.$store.dispatch("searchRepo", finalobj);
      this.model.repo_id = data.id;
      this.model.repo_name = data.name;
    },
    postData() {
      this.apiParams["data"] = this.model;
      this.$store.dispatch("setWebHook", this.model);
      this.$store.dispatch("protectBranch", this.model);
      return this.$store.dispatch("createTableData", this.apiParams);
    },
  },
};
</script>
